// Config.h
//
/////////////////////////////////////////////////////////////////////////////

#ifndef RESCUE_CONFIG_H
#define RESCUE_CONFIG_H

#include <string>

typedef std::string string;

namespace Librescue {
  /////////////////////////////////////////////////////////////////////////
  // Config

  /** ե䥳ޥɥ饤ꤵѥ᥿ */
  class Config {
  protected:
#		define P(type_, name_, value_)   type_ m_##name_;
#		include "parameters.h"
#		undef P
		
  public:
	virtual ~Config();
	Config();
		
#		define P(type_, name_, value_)   type_ name_() const { return m_##name_; }
#		include "parameters.h"
#		undef P

	/**
	 * ե뤫ץѥƥɤ߹ࡣ
	 * @param	filename
	 *		եΥե̾
	 */
	bool readConfigFile(const char* filename);
		
	/**
	 * ץѥƥ򹹿롣
	 * @return
	 *		顼ȯ false˹줿 true
	 * @param	name
	 *		ץѥƥ̾
	 * @param	value
	 *		ץѥƥͤɽʸؤΥݥ󥿡
	 */
	bool setValue(const char* name, const char* value);
		
	//	Config(const Config& source);
	//	Config& operator= (const Config& rhs);
	//	bool operator== (const Config& rhs) const;
  };
	
  /////////////////////////////////////////////////////////////////////////
} // namespace Rescue

#endif
